from lingpy import *

names_ = {
        "Indo-European.Danish": ['Danish'],
        "Indo-European.Dutch": ['Dutch'],
        "Indo-European.English": ['English'],
        "Indo-European.Icelandic": ['Icelandic'],
        "Indo-European.Latvian": ['Latvian'],
        #"Indo-European.Lithuanian": ['Lithuanian'],
        "Indo-European.Standard_German": ['German'],
        "Indo-European.Swedish": ['Swedish'],
        "Indo-European.Greek": ['Greek'],
        "Indo-European.Hindi": ['Hindi'],
        "Indo-European.Polish": ['Polish'],
        "Indo-European.Russian": ['Russian'],
        "Indo-European.Bulgarian": ['Bulgarian'],
        "Indo-European.Spanish": ['Spanish'],
        "Indo-European.Italian": ['Italian'],
        "Indo-European.French": ['French'],
        "Indo-European.Portuguese": ['Portuguese'],
        "Indo-European.Romanian": ['Romanian'],
        "Indo-European.Nepali": ['Nepali'],
        "Sino-Tibetan.Tibetan_Written": ['Tibetan'],
        "Sino-Tibetan.Mandarin": ['Chinese'],
        "Sino-Tibetan.Burmese": ['Burmese'],
        #"Tai-Kadai.Tai": ['Tai'],
        #"Tai-Kadai.Siamese": ['Siamese'],
        "Uralic.Finnish": ['Finnish'],
        "Uralic.Estonian": ['Estonian'],
        "Mongolic.Mongolian": ['Mongolian'],
        "Turkic.Turkish": ['Turkish'],
        "Kartvelian.Georgian": ['Georgian'],
        "Dravidian.Tamil": ['Tamil'],
        "Indo-European.Armenian": ['Armenian'],
        "Nakh-Daghestanian.Lezgi": ['Lezghian'],
        "Sino-Tibetan.JIANCHUAN_BAI": ['Bai'],
        "Indo-European.Eastern_Armenian": ['Armenian']
        }
names = {}
for n, data in names_.items():
    names[n.upper()] = data

longnames = open('data/euaMinus_longnames.txt').read().split('\n')
distances = []
indices = {}
with open('data/euaMinus-NWPV.phy') as f:
    lines = f.readlines()
    for i, line in enumerate(lines[1:]):
        if longnames[i].upper() in names:
            indices[names[longnames[i].upper()][0]] = i
        distances += [[x for x in line.strip().split()[1:]]]

snames = sorted(indices)
matrix = [['' for x in snames] for y in snames]
for i, nameA in enumerate(snames):
    for j, nameB in enumerate(snames):
        idxA = indices[nameA]
        idxB = indices[nameB]
        matrix[i][j] = distances[idxA][idxB]
with open('O_matrix.dst', 'w') as f:
    f.write(' {0}\n'.format(len(snames)))
    for i, name in enumerate(snames):
        f.write('{0:10} '.format(name))
        f.write(' '.join(matrix[i])+'\n')
        
words_ = csv2list('I_words.csv')
words = words_[0][1:]
D = {0: ['doculect', 'concept', 'ipa', 'tokens']}
idx = 1
for line in words_[1:]:
    taxon = line[0]
    if taxon not in snames:
        print(taxon)
        raise ValueError
    for i, tks in enumerate(line[1:]):
        if tks.strip():
            concept = words[i]
            D[idx] = [taxon, concept, tks.replace(' ', ''), tks.split(' ')]
            idx += 1
lex = LexStat(D)
lex.cluster(method='sca', threshold=0.45, ref='cogid')
lex.output('tsv', filename='O_animals', ignore='all', prettify=False)
paps = lex.get_paps(ref='cogid')
etd = lex.get_etymdict(ref='cogid', entry='concept')
with open('O_animals-paps.tsv', 'w') as f:
    f.write('ID\tCONCEPT\t'+'\t'.join(lex.taxa)+'\n')
    for idx in sorted(etd):
        f.write(str(idx)+'\t'+str([x[0] for x in etd[idx] if x][0]
            )+'\t'+'\t'.join([str(x) for x in paps[idx]])+'\n')

# compute pairwise distances
for concept in lex.rows:
    matrix = [[0 for x in snames] for y in snames]
    words = lex.get_list(row=concept, flat=True, entry='tokens')
    langs = lex.get_list(row=concept, flat=True, entry='doculect')
    for i, languageA in enumerate(snames):
        for j, languageB in enumerate(snames):
            if i < j:
                tkA = words[langs.index(languageA)]
                tkB = words[langs.index(languageB)]
                pair = Pairwise(tkA, tkB)
                pair.align(distance=True)
                matrix[i][j] = pair.alignments[0][2]
                matrix[j][i] = matrix[i][j]
    with open('O_'+concept+'.dst', 'w') as f:
        f.write(' {0}\n'.format(len(snames)))
        for i, language in enumerate(snames):
            f.write('{0:10} '.format(language))
            f.write(' '.join(['{0:.2f}'.format(x) for x in matrix[i]])+'\n')

